//+------------------------------------------------------------------+
//|                                                         4_MA.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Yellow
#property indicator_color2 Gray
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 White
#property indicator_color6 Aqua
#property indicator_color7 Sienna
#property indicator_color8 Magenta

#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4
#property indicator_width4 4
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 2
#property indicator_width8 2

//#property indicator_level1 0.0
//#property indicator_levelcolor Silver
//#property indicator_levelstyle STYLE_DOT

//---- input parameters
 int     daugiklis    ;
extern int     HistMAper_01   =  21;         
extern int     HistMAper_02   =  55;         
extern int     HistMAper_03   =  89;         
extern int     HistMAper_04   =  233;        


extern string  ModeType       =  "0=SMA,1=EMA,2=SMMA,3=LWMA";
extern int     HistMode_01    =  1;
extern int     HistMode_02    =  1;
extern int     HistMode_03    =  1;
extern int     HistMode_04    =  1;


extern string  PriceType      =  "0=C,1=O,2=H,3=L,4=MEDIAN,5=TYPICAP,6=WEIGHTED";
extern int     HistP_Type_01  =  0;
extern int     HistP_Type_02  =  0;
extern int     HistP_Type_03  =  0;
extern int     HistP_Type_04  =  0;


//extern int     LineFilter1    =  2000;
//extern int     LineFilter2    =  2000;
  
//---- indicator buffers
double Histogram1[];
double Histogram2[];
double Histogram3[];
double Histogram4[];
double Line1[];
double Line2[];
double Line3[];
double Line4[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- additional buffers are used for counting
   IndicatorBuffers(8);
//---- drawing settings
   IndicatorDigits(5);

//---- indicator buffers mapping
   SetIndexStyle     (0,DRAW_HISTOGRAM);
   SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexBuffer    (0,Histogram1);//1.67
   
   SetIndexStyle     (1,DRAW_HISTOGRAM);
   SetIndexEmptyValue(1,EMPTY_VALUE);
   SetIndexBuffer    (1,Histogram2); //1.3  
   
   SetIndexStyle     (2,DRAW_HISTOGRAM);
   SetIndexEmptyValue(2,EMPTY_VALUE);
   SetIndexBuffer    (2,Histogram3); //1  
   
   SetIndexBuffer    (3,Histogram4);
   SetIndexEmptyValue(3,EMPTY_VALUE);
   SetIndexStyle     (3,DRAW_HISTOGRAM);//0.67
  
   SetIndexStyle     (4,DRAW_LINE);   
   SetIndexBuffer    (4,Line1);
   SetIndexEmptyValue(4,EMPTY_VALUE);
   //SetIndexArrow     (4,167);

   SetIndexStyle     (5,DRAW_LINE);   
   SetIndexBuffer    (5,Line2);
   SetIndexEmptyValue(5,EMPTY_VALUE);
   //SetIndexArrow     (5,167);
    
   SetIndexStyle     (6,DRAW_LINE); 
   SetIndexBuffer    (6,Line3);
   SetIndexEmptyValue(6,EMPTY_VALUE);   
   //SetIndexArrow     (4,167);
   
   SetIndexStyle     (7,DRAW_LINE); 
   SetIndexBuffer    (7,Line4);
   SetIndexEmptyValue(7,EMPTY_VALUE);   
   //SetIndexArrow     (5,167);
  
   //SetIndexLabel(0,NULL);
   //SetIndexLabel(1,NULL);
   
   
   int tf = Period();
 
   switch (tf)
     {
      case 1     : {daugiklis=30000;return (daugiklis);}
      case 5     : {daugiklis=25000;return (daugiklis);}
      case 15    : {daugiklis=20000;return (daugiklis);}
      case 30    : {daugiklis=10000;return (daugiklis);}
      case 60    : {daugiklis=6000;return (daugiklis);}
      case 240   : {daugiklis=3000;return (daugiklis);}
      case 1440  : {daugiklis=1000;return (daugiklis);}
      case 10080 : {daugiklis=500;return (daugiklis);}
      case 43200 : {daugiklis=300;return (daugiklis);}
      
     }
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Trend                                                            |
//+------------------------------------------------------------------+
int start()
  {
   int i,limit,counted_bars=IndicatorCounted();

    if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars; 

   for(i=limit; i>=0; i--)
   {
     double ma01_0   =iMA(Symbol(),0,HistMAper_01,0,HistMode_01,HistP_Type_01,i);
     double ma01_1   =iMA(Symbol(),0,HistMAper_01,0,HistMode_01,HistP_Type_01,i+1);
     
     double ma02_0   =iMA(Symbol(),0,HistMAper_02,0,HistMode_02,HistP_Type_01,i);
     double ma02_1   =iMA(Symbol(),0,HistMAper_02,0,HistMode_02,HistP_Type_01,i+1);
     
     double ma03_0   =iMA(Symbol(),0,HistMAper_03,0,HistMode_03,HistP_Type_03,i);
     double ma03_1   =iMA(Symbol(),0,HistMAper_03,0,HistMode_03,HistP_Type_03,i+1);
     
     double ma04_0   =iMA(Symbol(),0,HistMAper_04,0,HistMode_04,HistP_Type_04,i);     
     double ma04_1   =iMA(Symbol(),0,HistMAper_04,0,HistMode_04,HistP_Type_04,i+1);
  
   //  Stulpeliai 1  Yellow 1.67
   //Aukstas stulpelis
         
      if(ma01_0 - ma01_1 <= 0 && (ma02_0 - ma01_0) - (ma02_1 - ma01_1) >= 0){Histogram1[i] = -1.67;}
      else 
         {if(ma01_0 - ma01_1 >= 0 && (ma02_0 - ma01_0) - (ma02_1 - ma01_1) <= 0){Histogram1[i] = 1.67;}
          else Histogram1[i] = Histogram1[i+1];}
             
   //  Stulpeliai Gray 1.3
   //Vidutinis stulpelis
              
      if(ma02_0 - ma02_1 <= 0 && (ma02_0 - ma01_0) - (ma02_1 - ma01_1) >= 0){Histogram2[i] = -1.3;}
      else
         {if(ma02_0 - ma02_1 >= 0 && (ma02_0 - ma01_0) - (ma02_1 - ma01_1) <= 0){Histogram2[i] = 1.3;}      
          else Histogram2[i] = Histogram2[i+1];}
           
   //  Stulpeliai Gray 1
   //Zemas stulpelis
   
     if(ma03_0 - ma03_1 <= 0 && (ma03_0 - ma02_0) - (ma03_1 - ma02_1) >= 0){Histogram3[i] = -1;} 
     else
         {if(ma03_0 - ma03_1 >= 0 && (ma03_0 - ma02_0) - (ma03_1 - ma02_1) <= 0){Histogram3[i] = 1;}
          else Histogram3[i] = Histogram3[i+1];}
          
  //  Stulpeliai Gray 0,67
   //Zemas stulpelis
   
     if(ma04_0 - ma04_1 <= 0 && (ma04_0 - ma03_0) - (ma04_1 - ma03_1) >= 0){Histogram4[i] = -0.67;}          //pirkti
     else
        {if(ma04_0 - ma04_1 >= 0 && (ma04_0 - ma03_0) - (ma04_1 - ma03_1) <= 0){Histogram4[i] = 0.67;}         //parduoti
         else Histogram4[i] = Histogram4[i+1];}
         
  //  Linija White
   //Zemas stulpelis       
      double ma_s1 = ma01_0 - ma01_1;           //ma greitis      
      Line1[i] = ma_s1*daugiklis/10;        
      
      double ma_s2 = ma02_0 - ma02_1;           //ma greitis      
      Line2[i] = ma_s2*daugiklis;
          
      double ma_s3 = ma03_0 - ma03_1;           //ma greitis      
      Line3[i] = ma_s3*daugiklis;
          
      double ma_s4 = ma04_0 - ma04_1;                     
      Line4[i] = ma_s4*daugiklis;       
   //delta kilimo-kritimo greitis (0-1)
   //
     // ma4 = (ma04_0 - ma03_0) - (ma04_1 - ma03_1);           //delta ma greitis
      //deltaLine[i] = ma4*daugiklis;         //pirkti}
      
//----
 
      //if (LineFilter1 > 0)
      //{
      //if( MathAbs(Line[i]-Line[i+1]) < LineFilter1*Point ) Line[i]=Line[i+1];
      
      //if(/*deltaLine[i]>0 && Line[i]>0  &&*/ Histogram[i]>0 && D_Histogram[i]>0)Up[i]=1.5;
      
      //if(/*deltaLine[i]<0 && Line[i]<0  && */Histogram[i]<0 && D_Histogram[i]<0)Dn[i]=-1.5;   
      //}
      //if (LineFilter2>0)
      //{
      //if( MathAbs(deltaLine[i]-deltaLine[i+1]) < LineFilter2*Point ) deltaLine[i]=deltaLine[i+1];
      //}
   
   }
  return;
} 
      